# --------------------------------------------------- #
# Script of Saga III Woodwork.cgi Version 4 (1.4)
# Copyright (C) 2005-2007 Missing Link.
# --------------------------------------------------- #

# Woodwork /ǰ / #
@FI = (
        { cl => { Wd => 1, Ax => 1 },
          gf => 'tc=1',
          gv => 'lf=1,vt=2',
          ex => 10,
          rl => 78,
          dt => { nm => '',
                  cl => 'Fi',
                  id => 'Firewood',
                  im => 'firewood.gif',
                  qn => 1,
                  bp => 20,
                  db => 5,
                  wt => 1 } },
        { id => { Sandpaper => 1 },
          cl => { Wd => 1, Ax => 1 },
          ki => 'Wd',
          gf => 'tc=1',
          gv => 'lf=1,vt=2',
          ex => 10,
          rl => 68,
          dt => { nm => '',
                  cl => 'Mt',
                  id => 'Woodenstick',
                  im => 'woodenstick.gif',
                  qn => 1,
                  bp => 30,
                  wt => 0.4 } },
        { id => { Sandpaper => 1 },
          cl => { Wd => 1, Ax => 1 },
          ki => 'Wd',
          gf => 'tc=1',
          gv => 'lf=1,vt=2',
          ex => 10,
          rl => 68,
          dt => { nm => '',
                  cl => 'Mt',
                  id => 'Thinboard',
                  im => 'thinboard.gif',
                  qn => 1,
                  bp => 30,
                  wt => 0.4 } },
        { id => { Sandpaper => 1 },
          cl => { Wd => 1, Ax => 1 },
          ki => 'Wd',
          gf => 'tc=1',
          gv => 'lf=1,vt=2',
          ex => 10,
          rl => 68,
          dt => { nm => '',
                  cl => 'Mt',
                  id => 'Squaredlumber',
                  im => 'squaredlumber.gif',
                  qn => 1,
                  bp => 30,
                  wt => 0.6 } },
        { id => { Woodenstick => 1, Stone => 1 },
          cl => { Ca => 1 },
          gf => 'tc=1',
          gv => 'lf=1,vt=5',
          ex => 10,
          rl => 68,
          dt => { nm => '˵',
                  cl => 'Mi',
                  ql => 'Fu',
                  id => 'Stonemill',
                  im => 'stonemill.gif',
                  qn => 1,
                  bp => 30,
                  db => 40,
                  wt => 5 } },
        { id => { Thinboard => 3, Ironplate => 1 },
          cl => { Ca => 1 },
          gf => 'tc=1',
          gv => 'lf=1,vt=5',
          ex => 10,
          rl => 68,
          dt => { nm => '',
                  cl => 'Ba',
                  ql => 'Fu',
                  id => 'Barrel',
                  im => 'barrel.gif',
                  qn => 1,
                  bp => 150,
                  db => 80,
                  wt => 2.7 } },
        { id => { Thinboard => 1, Woodenstick => 2 },
          cl => { Ca => 1 },
          ki => 'Thinboard',
          gf => 'tc=1',
          gv => 'lf=1,vt=5',
          ex => 10,
          rl => 68,
          dt => { nm => '  ',
                  cl => 'Tp',
                  id => 'Woodenanimaltrap',
                  im => 'woodentrap.gif',
                  qn => 1,
                  bp => 90,
                  ef => 'forest',
                  wt => 0.8 } },
        { id => { Woodenstick => 1, Thread => 1 },
          cl => { Ca => 1 },
          gf => 'tc=1',
          gv => 'lf=1,vt=5',
          ex => 10,
          rl => 68,
          dt => { nm => ' ˴',
                  cl => 'Fr',
                  id => 'Fishingrod02',
                  im => 'fishingrod1.gif',
                  qn => 1,
                  bp => 45,
                  ef => 4,
                  db => 50,
                  wt => 0.6 } },
        { id => { Thinboard => 5 },
          cl => { Ca => 1 },
          gf => 'tc=3',
          gv => 'lf=3,vt=5',
          ex => 30,
          rl => 64,
          dt => { nm => '',
                  cl => 'Kn',
                  id => 'Kennel',
                  im => 'kennel.gif',
                  qn => 1,
                  bp => 150,
                  wt => 2 } },
        { id => { Thinboard => 5 },
          cl => { Ca => 1 },
          gf => 'tc=3',
          gv => 'lf=3,vt=5',
          ex => 30,
          rl => 64,
          dt => { nm => '',
                  cl => 'Sf',
                  id => 'Shelf',
                  im => 'shelf.gif',
                  qn => 1,
                  bp => 150,
                  wt => 2 } },
        { id => { Thinboard => 1, Squaredlumber => 1 },
          cl => { Ca => 1 },
          ki => 'Thinboard',
          gf => 'tc=2',
          gv => 'lf=2,vt=5',
          ex => 20,
          rl => 66,
          dt => { nm => ' ',
                  cl => 'Sh',
                  id => 'Woodenshield',
                  ql => 'Lh',
                  im => 'woodenshield.gif',
                  qn => 1,
                  bp => 60,
                  ef => 4,
                  db => 40,
                  wt => 1,
                  cp => 'st=3' } },
        { id => { Thinboard => 1, Ironplate => 1 },
          cl => { Ca => 1 },
          ki => 'Thinboard',
          gf => 'tc=5',
          gv => 'lf=5,vt=5',
          ex => 50,
          rl => 60,
          dt => { nm => ' ',
                  cl => 'Sh',
                  id => 'Woodenshield',
                  ql => 'Lh',
                  im => 'woodenshield.gif',
                  qn => 1,
                  bp => 90,
                  ef => 8,
                  db => 40,
                  wt => 1,
                  cp => 'st=6' } },
        { id => { Thinboard => 2, Ironplate => 2 },
          cl => { Ca => 1 },
          ki => 'Thinboard',
          gf => 'tc=8',
          gv => 'lf=8,vt=5',
          ex => 80,
          rl => 54,
          dt => { nm => 'īƮ ',
                  cl => 'Sh',
                  id => 'Kiteshield',
                  ql => 'Lh',
                  im => 'kiteshield.gif',
                  qn => 1,
                  bp => 180,
                  ef => 12,
                  db => 40,
                  wt => 2,
                  cp => 'st=9' } },
        { id => { Squaredlumber => 1, Sandpaper => 3 },
          cl => { Ca => 1 },
          ki => 'Squaredlumber',
          gf => 'tc=2',
          gv => 'lf=2,vt=5',
          ex => 20,
          rl => 66,
          dt => { nm => '',
                  cl => 'Cl',
                  id => 'Club',
                  ql => 'Rh',
                  im => 'club.gif',
                  qn => 1,
                  bp => 60,
                  ef => 'S2',
                  db => 40,
                  wt => 0.5,
                  cp => 'tc=2' } },
        { id => { Chain => 1, Woodenstick => 3 },
          cl => { Ca => 1 },
          ki => 'Chain',
          gf => 'tc=5',
          gv => 'lf=5,vt=5',
          ex => 50,
          rl => 60,
          dt => { nm => '',
                  cl => 'Cl',
                  id => 'Threejointrod',
                  ql => 'Rh,Dh',
                  im => 'threejointrod.gif',
                  qn => 1,
                  bp => 85,
                  ef => 'S4',
                  db => 40,
                  wt => 1.7,
                  cp => 'tc=5' } },
        { id => { Woodenstick => 1, Hammerhead => 1 },
          cl => { Ca => 1 },
          ki => 'Woodenstick',
          gf => 'tc=8',
          gv => 'lf=8,vt=5',
          ex => 70,
          rl => 54,
          dt => { nm => 'ö',
                  cl => 'Cl',
                  id => 'Mace',
                  ql => 'Rh',
                  im => 'mace.gif',
                  qn => 1,
                  bp => 75,
                  ef => 'S6',
                  db => 40,
                  wt => 3,
                  cp => 'tc=8' } },
        { id => { Woodenstick => 1, Redpotion => 1 },
          cl => { Ca => 1 },
          ki => 'Woodenstick',
          gf => 'tc=3',
          gv => 'lf=3,vt=5',
          ex => 30,
          rl => 64,
          dt => { nm => ' ',
                  cl => 'Wn',
                  id => 'Woodwand',
                  ql => 'Rh',
                  im => 'woodwand.gif',
                  qn => 1,
                  bp => 50,
                  ef => 1.1,
                  db => 40,
                  wt => 0.4,
                  cp => 'in=6' } },
        { id => { Woodenstick => 1, Redpotion => 3 },
          cl => { Ca => 1 },
          ki => 'Woodenstick',
          gf => 'tc=6',
          gv => 'lf=6,vt=5',
          ex => 60,
          rl => 58,
          dt => { nm => ' ',
                  cl => 'Wn',
                  id => 'Magicwand',
                  ql => 'Rh',
                  im => 'magicwand.gif',
                  qn => 1,
                  bp => 120,
                  ef => 1.2,
                  db => 40,
                  wt => 2,
                  cp => 'in=9' } },
        { id => { Woodenstick => 1, Thread => 1 },
          cl => { Ca => 1 },
          ki => 'Woodenstick',
          gf => 'tc=3',
          gv => 'lf=3,vt=5',
          ex => 30,
          rl => 64,
          dt => { nm => '',
                  cl => 'Bo',
                  id => 'Shortbow',
                  ql => 'Rh,Dh',
                  im => 'shortbow.gif',
                  qn => 1,
                  bp => 45,
                  ef => 3,
                  db => 40,
                  wt => 0.6,
                  cp => 'tc=1' } },
        { id => { Woodenstick => 2, Thread => 2, Sandpaper => 3 },
          cl => { Ca => 1 },
          ki => 'Woodenstick',
          gf => 'tc=6',
          gv => 'lf=6,vt=5',
          ex => 60,
          rl => 58,
          dt => { nm => 'պ',
                  cl => 'Bo',
                  id => 'Longbow',
                  ql => 'Rh,Dh',
                  im => 'longbow.gif',
                  qn => 1,
                  bp => 120,
                  ef => 7,
                  db => 40,
                  wt => 1.2,
                  cp => 'tc=4' } },
        { id => { Thinboard => 10, Ironplate => 3 },
          cl => { Ca => 1, Ct => 2 },
          gf => 'tc=7',
          gv => 'lf=7,vt=5',
          ex => 70,
          rl => 56,
          dt => { nm => 'ڱ׼ Ǹ',
                  cl => 'Cn',
                  id => 'Kogg',
                  im => 'deed.gif',
                  qn => 1,
                  bp => 540,
                  wt => 0.1 } },
        { id => { Woodenstick => 3 },
          cl => { Ca => 1 },
          gf => 'tc=3',
          gv => 'lf=3,vt=5',
          ex => 30,
          rl => 64,
          dt => { nm => ' ',
                  cl => 'Sm',
                  id => 'Spoolholder',
                  im => 'spoolholder.gif',
                  qn => 1,
                  bp => 90,
                  db => 30,
                  wt => 1.2 } },
        { id => { Thinboard => 5, Woodenstick => 5 },
          cl => { Ca => 1 },
          gf => 'tc=5',
          gv => 'lf=5,vt=5',
          ex => 50,
          rl => 60,
          dt => { nm => '',
                  cl => 'Sm',
                  id => 'Spinningwheel',
                  ql => 'Fu',
                  im => 'spinningwheel.gif',
                  qn => 1,
                  bp => 300,
                  db => 100,
                  wt => 5 } },
        { id => { Thinboard => 5, Woodenstick => 5 },
          cl => { Ca => 1 },
          gf => 'tc=8',
          gv => 'lf=8,vt=5',
          ex => 80,
          rl => 54,
          dt => { nm => 'Ʋ',
                  cl => 'Lm',
                  id => 'Loom',
                  ql => 'Fu',
                  im => 'loom.gif',
                  qn => 1,
                  bp => 300,
                  db => 100,
                  wt => 5 } },
);

# --------------------------------------------------- #
1;
